**source:**https://leetcode.com/problems/3sum/**C/C++**

**Solution to LeetCode**problem

**15**.

**3Sum**.

## Problem

Given an integer array nums, return all the triplets `[nums[i], nums[j], nums[k]]`

such that `i != j`

, `i != k`

, and `j != k`

, and `nums[i] + nums[j] + nums[k] == 0`

.

Notice that the solution set must not contain duplicate triplets.

## Examples

**Example 1:**

Input:nums = [-1,0,1,2,-1,-4]

Output:[[-1,-1,2],[-1,0,1]]

Explanation:

nums[0] + nums[1] + nums[2] = (-1) + 0 + 1 = 0.

nums[1] + nums[2] + nums[4] = 0 + 1 + (-1) = 0.

nums[0] + nums[3] + nums[4] = (-1) + 2 + (-1) = 0.

The distinct triplets are [-1,0,1] and [-1,-1,2].

Notice that the order of the output and the order of the triplets does not matter.

**Example 2:**

Input:nums = [0,1,1]

Output:[]

Explanation:The only possible triplet does not sum up to 0.

**Example 3:**

Input:nums = [0,0,0]

Output:[[0,0,0]]

Explanation:The only possible triplet sums up to 0.

## Constraints

`3 <= nums.length <= 3000`

`-10`

^{5}<= nums[i] <= 10^{5}

## Solution

We will use a Two Pointers technique.

- First we sort the numbers.
- We start with the first element.
- Set a pointer next to this element (
`left`

pointer). - Set a pointer to the end of the array (
`right`

pointer).

- Set a pointer next to this element (
- We add together the 3 elements (the number where we are in the iteration, plus the numbers at the two pointers indexes).
- If the sum is
`0`

we add the numbers to the result. - If result is
`< 0`

we move the left pointer. - If result is
`> 0`

we move the right pointer.

- If the sum is

To optimize, after procesing a set of numbers, we can move the pointers until the new number is different to the last processed.

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35

class Solution {
public:
vector<vector<int>> threeSum(vector<int>& nums) {
vector<vector<int>> result;
int l;
int r;
sort(nums.begin(), nums.end());
for(int i=0; i<nums.size()-2; i++) {
if(i>0 && nums[i] == nums[i-1])
continue;
l=i+1;
r=nums.size()-1;
while(l<r) {
int res = nums[i] + nums[l] + nums[r];
if (res == 0) {
result.push_back({nums[i], nums[l], nums[r]});
l += 1;
r -= 1;
while (l<r && nums[l-1] == nums[l])
l += 1;
while (r>l && nums[r+1] == nums[r])
r -= 1;
}
else if (res > 0)
r -= 1;
else
l += 1;
}
}
return result;
}
};